<?php
/* utf8-marker = äöüß */

/*
 * Meta-Tags ---> (Meta-Tags-Plus 1.4) Olaf Penschke, olape, <olaf.penschke@gmx.de>
 * https://olaf.penschke.net
 * http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 *
============================================================================
 *
 * Meta-Tags - module admin
 *
 * Admin-interface for configuring the plugin
 * via the standard-functions of pluginloader.
 *
 * PHP versions 4 and 5
 *
 * @category  CMSimple_XH
 * @package   Metatags
 * @author    Martin Damken <kontakt@zeichenkombinat.de>
 * @author    The CMSimple_XH developers <devs@cmsimple-xh.org>
 * @copyright 2009-2017 The CMSimple_XH developers <http://cmsimple-xh.org/?The_Team>
 * @license   http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 * @link      http://cmsimple-xh.org/

============================================================================
*/

/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if(!defined('PLUGINLOADER')) {
    die(
        'Plugin '. basename(dirname(__FILE__))
        . ' requires a newer version of the Pluginloader. No direct access.'
    );
}
//**************************************************************************
// dynamisches Menü unter Plugin

if(function_exists('XH_registerStandardPluginMenuItems')) {
    XH_registerStandardPluginMenuItems(true);
}
//**************************************************************************
if(XH_wantsPluginAdministration('meta_tags_plus')) {
    $o .= print_plugin_admin('on');
    
// Menü in der Pluginkopfzeile

    if(($admin != 'plugin_main') && ($admin != ''))
    {
        $o .= plugin_admin_common($action, $admin, $plugin);
    }
//**************************************************************************
//**************************************************************************
$op_plugin_name = 'Meta-Tags-Plus';
$op_plugin_version = '1.4';
$op_copyright = '2016';
$op_cms_version_arr = array('1.7.0', '1.7.1', '1.7.2', '1.7.3', '1.7.4');
$op_php_version = '5.3';
//**************************************************************************
//**************************************************************************
    //Anzeige nur auf Startseitedes Plugins und unter Info
    if(($admin == '') || ($admin == 'plugin_main'))
    {
        $o .= '<div class="xhContainer metatagsplus_admin">';
        /*$o .= "\n" . '<h1>'
           . ucfirst(str_replace('_', ' ', $plugin)) . '</h1>';*/

        $o .= '<img class="metatagsplus_admin_logo" alt="Logo Meta Tags Plus" src="'
           . $pth['folder']['plugins'] . 'meta_tags_plus/img/logo-meta-tags-plus-200.png">';
        $o .= "\n" . '<h1>' . $plugin_tx['meta_tags_plus']['admin_for'] . ' CMSimple_XH</h1>
        <p><b>Version: ' . $op_plugin_version . '</b></p>
        <p>Metatags Copyright The CMSimple_XH developers<br>'
           . $op_plugin_name . ', Copyright © ' . $op_copyright
           . ' <a target="_blank" href="http://olaf.penschke.net/?CMSimple_XH/Plugins">Olaf Penschke</a></p>
        <p> </p>
        <p><a target="_blank" href="http://olaf.penschke.net/?Kontakt&xh_mailform_subject='
           . $op_plugin_name . '">' . $plugin_tx['meta_tags_plus']['admin_contact'] . '</a></p>
        <p> </p>
        <p><b>' . $op_plugin_name . '</b> ' . $plugin_tx['meta_tags_plus']['admin_gplv3_1']
           . ' <a target="_blank" href="https://www.gnu.org/licenses/gpl-3.0.de.html">GPLv3</a> '
           . $plugin_tx['meta_tags_plus']['admin_gplv3_2'] . '</p>
        <hr>
        <p>Adapted for CMSimple_XH ' . $op_cms_version_arr[0] . ' - ' . end($op_cms_version_arr)
           . ' by <a target="_blank" href="http://www.cmsimple-xh.org/">cmsimple-xh.org</a></p>';

//**************************************************************************
// System check
//**************************************************************************
        $o .= '<h2>System Check</h2>';
// original Plugin meta_tags vorhanden?
        if(file_exists($pth['folder']['plugins'] . 'meta_tags/')) {
           $o .= '<p class="xh_fail">'
              . 'The original plugin meta tags must be deleted!</p>'
              . "\n";
        } else {
            $o .= '<p class="xh_success">'
               . 'The original plugin meta tags is deleted.</p>'
               . "\n";
        }
// CMSimple_XH Version
        $op_cms_version_tmp = CMSIMPLE_XH_VERSION;
        $op_cms_version_tmp = str_replace(array('CMSimple_XH '), '', $op_cms_version_tmp);
        if(in_array($op_cms_version_tmp, $op_cms_version_arr, true)) {
            $o .= '<p class="xh_success">'
               . CMSIMPLE_XH_VERSION
               . ' &#x2192 supported</p>'
               . "\n";
        } else {
            $o .= '<p class="xh_fail">'
               . CMSIMPLE_XH_VERSION
               . ' &#x2192 I hope it is still supported. It was designed for '
               . $op_cms_version_arr[0]
               . ' - '
               . end($op_cms_version_arr)
               . '.</p>'
               . "\n";
        }
// PHP Version
        if(version_compare(phpversion(), $op_php_version, '<')) {
            $o .= '<p class="xh_fail">PHP: '
               . phpversion()
               . ' &#x2192 not supported</p>'
               . "\n";
        } else {
            $o .= '<p class="xh_success">PHP: '
               . phpversion()
               . ' &#x2192 supported</p>' 
               . "\n";
        }
// Schreibrechte
        $op_filename_arr = array($pth['folder']['plugins'] . 'meta_tags_plus/css/',
                                 $pth['folder']['plugins'] . 'meta_tags_plus/css/stylesheet.css',
                                 $pth['folder']['plugins'] . 'meta_tags_plus/config/', 
                                 $pth['folder']['plugins'] . 'meta_tags_plus/config/config.php',
                                 $pth['folder']['plugins'] . 'meta_tags_plus/languages/',
                                 $pth['folder']['plugins'] . 'meta_tags_plus/languages/' . $sl . '.php');
        foreach($op_filename_arr as $op_filename) {
            if(is_writable($op_filename)) {
                $o .= '<p class="xh_success">'
                   . $op_filename
                   . ' &#x2192 writable</p>'
                   . "\n";
            } else {
                $o .= '<p class="xh_fail">'
                   . $op_filename
                   . ' &#x2192 not writable</p>'
                   . "\n";
            }
        }
    $o .= '</div>';
    }
}
//**************************************************************************
//additional CSS-Class for configuration, stylesheet and language
//replaces the plugin name
if((isset($_GET['meta_tags_plus'])) && (isset($_GET['admin']))) {
    if($_GET['admin'] == 'plugin_config') {
        $o = str_ireplace('<h1>Meta_tags_plus', '<h1>' . $op_plugin_name, $o);
        $o = '<div class="xhContainer meta_tags_plus_conf">' . $o . '</div>';
    }
    if($_GET['admin'] == 'plugin_stylesheet') {
        $o = str_ireplace('<h1>Meta_tags_plus', '<h1>' . $op_plugin_name, $o);
        $o = '<div class="xhContainer meta_tags_plus_stylesheet">' . $o . '</div>';
    }
    if($_GET['admin'] == 'plugin_language') {
        $o = str_ireplace('<h1>Meta_tags_plus', '<h1>' . $op_plugin_name, $o);
        $o = '<div class="xhContainer meta_tags_plus_language">' . $o . '</div>';
    }
}
