<?php
/* utf8-marker = äöüß */

/*
 * Meta-Tags ---> (Meta-Tags-Plus 1.4) Olaf Penschke, olape, <olaf.penschke@gmx.de>
 * https://olaf.penschke.net
 * http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 *
============================================================================
 *
 * Meta-Tags - main index.php
 *
 * Stores meta-tags (description, keywords, title and robots) per page.
 * index.php is called by pluginloader and returns HTML META ELEMENTS to template.
 *
 * @category  CMSimple_XH
 * @package   Metatags
 * @author    Martin Damken <kontakt@zeichenkombinat.de>
 * @author    The CMSimple_XH developers <devs@cmsimple-xh.org>
 * @copyright 2009-2017 The CMSimple_XH developers <http://cmsimple-xh.org/?The_Team>
 * @license   http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 * @link      http://cmsimple-xh.org/

============================================================================
*/

require_once(__DIR__ . '/metatagsfuncs.php');

//==========================================================================

/*
 * Check if PLUGINLOADER is calling and die if not.
 */
if(!defined('PLUGINLOADER')) {
    die(
        'Plugin '. basename(dirname(__FILE__))
        . ' requires a newer version of the Pluginloader. No direct access.'
    );
}
//==========================================================================

/*
 * Add used interests to router.
 */
$pd_router->add_interest('description');
$pd_router->add_interest('keywords');
$pd_router->add_interest('title');
$pd_router->add_interest('robots');

/*
 * Add a tab for admin-menu.
 */
$pd_router->add_tab(
    $plugin_tx['meta_tags_plus']['tab'],
    $pth['folder']['plugins'] . 'meta_tags_plus/Metatags_view.php'
);

/*
 * Set the meta tags contents.
 */
if(!empty($pd_current['title'])) {
    $cf['site']['title'] = $pd_current['title'];
    $cf['title']['format'] = "{SITE}";
}
// OP Beginn Titel #########################################################
else if(($plugin_cf['meta_tags_plus']['Title'])
     && (!empty($c[$pd_s]))) {
        op_MTP_PageTitle();
}

if(!empty($pd_current['description'])) {
    $tx['meta']['description'] = $pd_current['description'];
}
// OP Beginn Description ###################################################
else if(($plugin_cf['meta_tags_plus']['Description'])
     && (!empty($c[$pd_s]))) {
        op_MTP_PageDescription();
}

if(!empty($pd_current['keywords'])) {
    $tx['meta']['keywords'] = $pd_current['keywords'];
}
// OP Beginn Keywords ######################################################
else if(($plugin_cf['meta_tags_plus']['Keywords'])
     && ($plugin_tx['meta_tags_plus']['Keywords_Pool'])
     && (!empty($c[$pd_s]))) {
        op_MTP_PageKeywords();
}

if(!empty($pd_current['robots'])) {
    $cf['meta']['robots'] = $pd_current['robots'];
}
// OP Beginn Stichwortliste ################################################
if(($plugin_cf['meta_tags_plus']['Tags_List']) 
&& ($pd_s >= 0) 
&& ($tx['meta']['keywords'] != '')) {
    if(!$edit) {
        $op_mtp_otmp = '<div class="mtp_tags_list"><p><span>'
                      . $plugin_tx['meta_tags_plus']['Tags_List_Label']
                      . '</span>'
                      . op_MTP_TagsList()
                      . '</p></div>';
        $c[$pd_s] .= $op_mtp_otmp;
    }
}
