<?php
/* utf8-marker = äöüß */

/*
 * Meta-Tags ---> (Meta-Tags-Plus 1.4) Olaf Penschke, olape, <olaf.penschke@gmx.de>
 * https://olaf.penschke.net
 * http://www.gnu.org/licenses/gpl-3.0.en.html GNU GPLv3
 *
============================================================================
*/

if('metatagsfuncs.php' == basename($_SERVER['SCRIPT_FILENAME']))
{
    die('No direct access.');
}

// content(), $c[$s], $c[$pd_s]
// http://cmsimpleforum.com/viewtopic.php?f=16&t=9829&p=51497#p51492
function op_MTP_PageTitle() {

global $plugin_cf, $cf, $plugin_tx, $tx, $c, $pd_s, $xh_publisher, $h;

    // Mindestlänge des vorhandenen Titels // empfohlen 50 Zeichen
    if(($plugin_cf['meta_tags_plus']['isTitleLen'])
     && (is_numeric($plugin_cf['meta_tags_plus']['isTitleLen']))) {
        $op_istitleLen = $plugin_cf['meta_tags_plus']['isTitleLen'];
    } else {
        $op_istitleLen = 50;
    }

    if((strlen(utf8_decode($cf['site']['title']))) < ($op_istitleLen)) {
        // Maximale Länge des Titels, ab da wird abgeschnitten // empfohlen 77 Zeichen
        if(($plugin_cf['meta_tags_plus']['maxTitleLen'])
        && (is_numeric($plugin_cf['meta_tags_plus']['maxTitleLen']))) {
            $op_maxtitleLen = $plugin_cf['meta_tags_plus']['maxTitleLen'];
        } else {
            $op_maxtitleLen = 77;
        }

        // Wörter, die nicht im Titel enthalten sein sollen
        if($plugin_tx['meta_tags_plus']['Title_Blacklist']) {
            $op_no_title_arr = explode('|', $plugin_tx['meta_tags_plus']['Title_Blacklist']);
        }

        // Titel aus Inhalt erzeugen
        $op_tmptitle = $c[$pd_s];
        // span-Tags entfernen, falls Überschriften formatiert
        $op_tmptitle = preg_replace(array('#\<span[^\>]*\>#Uuis', '#\<\/span\>#Uuis'), '', $op_tmptitle);
        // Textmarke (<a id="textmarke"></a>) entfernen.
        $op_tmptitle = preg_replace(array('#\<a id[^\>]*\>#Uuis', '#\<\/a\>#Uuis'), '', $op_tmptitle);
        // ersetzt Break durch Leerzeichen
        $op_tmptitle = str_ireplace(array('<br>', '<br />'), ' ', $op_tmptitle);
        // Überschriften suchen
        preg_match_all('#\<h[^\>]*\>[^\<]*\<\/h.\>#Uuis', $op_tmptitle, $op_heading);
        $op_title = implode(' | ', $op_heading[0]);
        // Submenu  mit in den Titel
        if($plugin_cf['meta_tags_plus']['Submenu_in']) {
            if(submenu()) {
                $op_title_subm = str_replace('<li', ' | <li', submenu());
                $op_title_subm = str_replace($tx['submenu']['heading'], ' ', $op_title_subm);
                $op_title = $op_title . $op_title_subm;
            }
            if($pd_s === $xh_publisher->getFirstPublishedPage()) {
                $op_title_subp = op_MTP_FindSubpages();
                $op_title = $op_title . $op_title_subp;
            }
        }
        // Menüpunkt mit in Title
        if($plugin_cf['meta_tags_plus']['CurrentMenuItem_in']) {
            $op_title = $op_title . ' | ' . $h[$pd_s];
        }
        $op_title = strip_tags($op_title);
        // Wörter, die nicht im Titel enthalten sein sollen entfernen (durch Leerzeichen ersetzen)
        if($op_no_title_arr) {
            $op_title = str_replace($op_no_title_arr, ' ', $op_title);
        }
        // Titel inkl.Seitenname
        if($plugin_cf['meta_tags_plus']['Sitename_in']) {
            $op_tmp_SiteTitel = $cf['site']['title'] . ' | ' . $op_title;
        } else {
            $op_tmp_SiteTitel = $op_title;
        }
        $op_tmp_SiteTitel = html_entity_decode($op_tmp_SiteTitel, ENT_QUOTES, 'UTF-8');
        // entfernt alles ausser angegebene Zeichen, z.B. German Quotes, Gedankenstrich, ..., usw.
        $op_tmp_SiteTitel = preg_replace('#[^A-Za-z0-9' . $plugin_tx['meta_tags_plus']['Special_Characters'] . ']#u', ' ', $op_tmp_SiteTitel);
        // mehrere Leerzeichen auf eins reduzieren
        $op_tmp_SiteTitel = preg_replace('#[\s]{2,}#s', ' ', $op_tmp_SiteTitel);
        // doppelte Einträge entfernen, falls Titel aus Sprachdatei mit Überschriften übereinstimmt
        $op_tmp_SiteTitel = implode(' | ', array_unique(explode(' | ', $op_tmp_SiteTitel)));
        // falls Überschrift nur aus Füllwörtern (Sprachdatei) besteht
        $op_tmp_SiteTitel = str_replace(' | | ', ' | ', $op_tmp_SiteTitel);
        // Länge begrenzen
        if(strlen(utf8_decode($op_tmp_SiteTitel)) > $op_maxtitleLen) {
            $op_tmp_SiteTitel = substr($op_tmp_SiteTitel, 0, $op_maxtitleLen);
            // abschneiden bei Pipe
            $op_tmp_SiteTitel = substr($op_tmp_SiteTitel, 0, strrpos($op_tmp_SiteTitel, '|'));
        }
        // wenn erstes Zeichen ein '|', '-', ',', '&', ')' oder ein ' ' dann entfernen
        $op_tmp_SiteTitel = ltrim($op_tmp_SiteTitel, '|-,&) ');
        // wenn letztes Zeichen ein '|', '-', ',', '&', '(' oder ein ' ' dann entfernen
        $op_tmp_SiteTitel = rtrim($op_tmp_SiteTitel, '|-,&( ');
        // wenn neuer Titel länger als alter Titel
        if(strlen(utf8_decode($op_tmp_SiteTitel)) > strlen(utf8_decode($cf['site']['title']))) {
            $cf['site']['title'] = $op_tmp_SiteTitel;
            $cf['title']['format'] = "{SITE}";
        }
    }
}

// content(), $c[$s], $c[$pd_s]
// http://cmsimpleforum.com/viewtopic.php?f=16&t=9829&p=51497#p51492
function op_MTP_PageDescription() {

global $plugin_cf, $plugin_tx, $tx, $c, $pd_s;

    // Mindestlänge der neuen Description // empfohlen 100 bis 120 Zeichen
    if($plugin_cf['meta_tags_plus']['minDescriptionLen']) {
        $op_minDescriptionLen = $plugin_cf['meta_tags_plus']['minDescriptionLen'];
     } else {
        $op_minDescriptionLen = 100;
     }

    // Maximale Länge der Description, ab da wird abgeschnitten und mit $op_DescExt ergänzt // empfohlen 150 bis 160 Zeichen
    if($plugin_cf['meta_tags_plus']['maxDescriptionLen']) {
        $op_maxDescriptionLen = $plugin_cf['meta_tags_plus']['maxDescriptionLen'];
    } else {
         $op_maxDescriptionLen = 156;
    }

    // wird als letzte Zeichen an die Description angehängt
    $op_DescExt = " ..." ;

    // Description aus $c[$pd_s] erzeugen
    $op_tmpdescription = $c[$pd_s];
    // Wenn Andere Seitenüberschrift
    if((!empty($pd_current['heading'])) && ($pd_current['heading'] != '')) {
        $op_tmpdescription = $pd_current['heading'] . ', ' . $op_tmpdescription;
        // span-Tags entfernen, falls Überschriften formatiert
        $op_tmpdescription = preg_replace(array('#\<span[^\>]*\>#Uuis', '#\<\/span\>#Uuis'), '', $op_tmpdescription);
        // Erste Überschrift entfernen
        $op_tmpdescription = preg_replace('#\<h[^\>]*\>[^\<]*\<\/h.\>#Uuis', '', $op_tmpdescription, 1);
    } else {
        // Komma nach der ersten Überschrift der Seite einfügen
        $op_tmpdescription = preg_replace('#\<\/h.\>#Uuis', ', ', $op_tmpdescription, 1);
    }
    // ersetzt Break durch Leerzeichen
    $op_tmpdescription = str_ireplace(array('<br>', '<br />'), ' ', $op_tmpdescription);
    // entfernt script
    $op_tmpdescription = preg_replace('#\<script[^\>]*\>.*?\<\/script\>#umsi', '', $op_tmpdescription);
    // entfernt iframe
    $op_tmpdescription = preg_replace('#\<iframe[^\>]*\>.*?\<\/iframe\>#umsi', '', $op_tmpdescription);
    // entfernt #CMSimple ....;# z.B.: #CMSimple $druck="no";#
    $op_tmpdescription = preg_replace('#\#CMSimple[^\#]*\##Uuis', '', $op_tmpdescription);
    // entfernt {{{ .... }}} z.B.: {{{PLUGIN:video(..., oder {{{XH_mailform();}}}
    $op_tmpdescription = preg_replace('#\{\{\{[^\}]*\}\}\}#', '', $op_tmpdescription);
    $op_tmpdescription = strip_tags(html_entity_decode($op_tmpdescription, ENT_QUOTES, 'UTF-8'));
    // Zeilenumbrüche, geschützte Leerzeichen entfernen
    //$op_tmpdescription = str_replace(array("\r\n", "\r", "\n", "\t", "\n\r", "\r\n+", '&nbsp;', chr(13)), ' ', $op_tmpdescription);
    // entfernt Leerzeichen und Tabulatoren, vertikaler Tabulatoren, Zeilen- und Seitenvorschub, Wagenrücklauf
    $op_tmpdescription = preg_replace('#[[:space:]]#', ' ', $op_tmpdescription);
    // entfernt nicht druckbare Zeichen (Es gab immer wieder mehrfache "Leezeichen" am Stück, die nicht entfernt wurden)
    $op_tmpdescription = preg_replace('#[^[:print:]]#ums', ' ', $op_tmpdescription);
    // entfernt alles, ausser angegebene Zeichen, z.B. German Quotes, Gedankenstrich, ..., usw.
    $op_tmpdescription = preg_replace('#[^A-Za-z0-9' . $plugin_tx['meta_tags_plus']['Special_Characters'] . ']#u', ' ', $op_tmpdescription);
    // mehrere Leerzeichen auf eins reduzieren
    $op_tmpdescription = preg_replace('#[\s]{2,}#s', ' ', $op_tmpdescription);
    $op_tmpdescription = str_replace(array(' , ', ' . '), array(', ', '. '), $op_tmpdescription);
    // mögliche Leerzeichen am Anfang und am Ende entfernen
    $op_tmpdescription = trim($op_tmpdescription);
    if(strlen(utf8_decode($op_tmpdescription)) > $op_maxDescriptionLen) {
        // Länge begrenzen
        $op_tmpdescription = substr($op_tmpdescription, 0, $op_maxDescriptionLen);
        // nach ganzem Wort abschneiden und Punkte anfügen
        $op_tmpdescription = substr($op_tmpdescription, 0, strrpos($op_tmpdescription, ' ')) . $op_DescExt;
    }
    if(strlen(utf8_decode($op_tmpdescription)) > $op_minDescriptionLen) {
        $tx['meta']['description'] = $op_tmpdescription;
    }
}

// content(), $c[$s], $c[$pd_s]
// http://cmsimpleforum.com/viewtopic.php?f=16&t=9829&p=51497#p51492
function op_MTP_PageKeywords() {

global $plugin_tx, $tx, $c, $pd_s, $pd_current;

    $op_keywords = '';
    $op_tmpkeywords = $c[$pd_s];
    // entfernt script
    $op_tmpkeywords = preg_replace('#\<script[^\>]*\>.*?\<\/script\>#umsi', '', $op_tmpkeywords);
    // entfernt iframe
    $op_tmpkeywords = preg_replace('#\<iframe[^\>]*\>.*?\<\/iframe\>#umsi', '', $op_tmpkeywords);
    // entfernt #CMSimple ....;# z.B.: #CMSimple $druck="no";#
    $op_tmpkeywords = preg_replace('#\#CMSimple[^\#]*\##Uuis', '', $op_tmpkeywords);
    // entfernt {{{ .... }}} z.B.: {{{PLUGIN:video(..., oder {{{XH_mailform();}}}
    $op_tmpkeywords = preg_replace('#\{\{\{[^\}]*\}\}\}#', '', $op_tmpkeywords);
    $op_tmpkeywords = strip_tags(html_entity_decode($op_tmpkeywords, ENT_QUOTES, 'UTF-8'));
    // Wenn Andere Seitenüberschrift
    if((!empty($pd_current['heading'])) && ($pd_current['heading'] != '')) {
        $op_tmpkeywords = $pd_current['heading'] . ', ' . $op_tmpkeywords;
    }
    $op_key_pool = trim($plugin_tx['meta_tags_plus']['Keywords_Pool'], ' |');
    $op_keywords_arr = explode('|', $op_key_pool);
    // entfernt Leerzeichen, falls Keyword im Pool mit Leerzeichen
    $op_keywords_arr = array_map('trim', $op_keywords_arr);
    foreach($op_keywords_arr as $op_keyword_tmp) {
        if(preg_match_all('#\b' . $op_keyword_tmp . '\b#i', $op_tmpkeywords, $matches)) {
            //var_dump($matches);
            $op_keywords.= $op_keyword_tmp . ',';
        }
    }
    // entfernt Komma nach letztem Keyword
    $op_keywords = rtrim($op_keywords, ',');
    if($op_keywords) {
        $tx['meta']['keywords'] = $op_keywords;
    }
}

// $pd_s instead of $s --> first Page without Get
// https://cmsimpleforum.com/viewtopic.php?f=16&t=9829&start=10#p51492
function op_MTP_FindSubpages() {

global $pd_s, $l, $h, $xh_publisher;

    // if $pd_s < 0, i.e. setting or plugins
    if($pd_s < 0) {return false;}

    $supa_array = array();
    for($count = 0;;) {
        $count++;
        if($l[$pd_s + $count] == $l[$pd_s]) break;
        if($l[$pd_s + $count] < $l[$pd_s] + 2) {
            if(!$xh_publisher->isHidden($pd_s + $count)) {
                $supa_array[] = $h[$pd_s + $count];
            }
        }
    }

    $supa = ' | ' . implode(' | ', $supa_array);
return $supa;
}

// $pd_s instead of $s --> first Page without Get
// https://cmsimpleforum.com/viewtopic.php?f=16&t=9829&start=10#p51492
function op_MTP_TagsList() {

global $h, $pd_s, $tx, $plugin_cf;

if(isset($_GET['search'])) {
    $op_GET = preg_replace('#&?search[^&]*#is', '', $_SERVER['QUERY_STRING']);
} else {
    $op_GET = $_SERVER['QUERY_STRING'];
}

    $op_mtp_tagslist = $h[$pd_s] . ',' . $tx['meta']['keywords'];
    // falls Keywords mit Leerzeichen
    $op_mtp_tagslist = str_replace(array(' ,', ', ', ' , '), ',', $op_mtp_tagslist);
    // doppelte Einträge entfernen
    $op_mtp_tagslist_arr = explode(',', $op_mtp_tagslist);
    $op_mtp_tagslist_arr = array_unique($op_mtp_tagslist_arr);
    natsort($op_mtp_tagslist_arr);
    // Link erstellen, wenn aktiviert
    if($plugin_cf['meta_tags_plus']['Tags_List-Link']) {
        $op_mtp_tagslist = '';
        foreach($op_mtp_tagslist_arr as $i) {
            if($op_GET) {
                $op_mtp_taglink = '<a rel="nofollow" href="?'
                                 . $op_GET
                                 . '&search='
                                 . $i
                                 . '">'
                                 . $i
                                 . '</a>';
            } else {
                $op_mtp_taglink = '<a rel="nofollow" href="?&search='
                                 . $i
                                 . '">'
                                 . $i
                                 . '</a>';
            }
            $op_mtp_tagslist .= $op_mtp_taglink . ', ';
        }
    } else {
    // sonst einfacher String
        $op_mtp_tagslist = implode(', ', $op_mtp_tagslist_arr);
    }
    $op_mtp_tagslist = trim($op_mtp_tagslist, ', ');

return $op_mtp_tagslist;
}
